%define ocamlname ppx_deriving

Name:           ocaml-%{ocamlname}
Version:        4.2.1
Release:        1%{?dist}.emp1
Summary:        Type-driven code generation for OCaml
License:        MIT
URL:            https://github.com/whitequark/ppx_deriving
Source0:        %{ocamlname}-%{version}.tar.gz

Requires: 	ocaml >= 4.03.0
Requires:	ocaml-ocaml-migrate-parsetree
Requires:	ocaml-ppx_derivers
Requires:	ocaml-ppx_tools >= 4.02.3
Requires:	ocaml-result

BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml >= 4.03.0
BuildRequires:	ocaml-cppo
BuildRequires:	ocaml-cppo_ocamlbuild
BuildRequires:	ocaml-ounit
BuildRequires:	ocaml-ocaml-migrate-parsetree-devel
BuildRequires:	ocaml-ppx_derivers-devel
BuildRequires:	ocaml-ppx_tools-devel >= 4.02.3
BuildRequires:	ocaml-result-devel

%description
Type-driven code generation for OCaml

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-ocaml-migrate-parsetree-devel
Requires:	ocaml-ppx_derivers-devel
Requires:	ocaml-ppx_tools-devel >= 4.02.3
Requires:	ocaml-result-devel

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{ocamlname}-%{version}

%build
make build

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install
# fix path of executable
mv %{buildroot}/%{_libdir}/ocaml/lib/%{ocamlname}/%{ocamlname} \
   %{buildroot}/%{_libdir}/ocaml/%{ocamlname}/.

%check
make test

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.txt
%{_libdir}/ocaml/%{ocamlname}
%{_libdir}/ocaml/lib/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.md
%doc %{_libdir}/ocaml/doc/%{ocamlname}/CHANGELOG.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
